---
title: Break on DOM mutation
slug: Tools/Debugger/Break_on_DOM_mutation
tags:
  - DOM Mutation Breakpoint
  - Debugger
  - Debugging
  - Dev Tools
  - Tools
  - breakpoint
---
<p>{{ToolsSidebar}}</p>

<p>A DOM Mutation Breakpoint pauses the code when the DOM node on which you have set the breakpoint is modified.</p>

<p>You set a DOM Mutation Breakpoint in the <a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>. Navigate to the DOM node in which you are interested and use the context menu to set the breakpoint.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16894/dom_breakpoint_context.png" style="display: block; height: 400px; margin: 0px auto; width: 410px;"></p>

<p>There are three choices:</p>

<dl>
 <dt>Subtree Modification</dt>
 <dd>Execution pauses if any of the elementʼs descendant nodes are modified.<br>
 That means, the script execution is stopped whenever a child node or descendant node deeper in the DOM structure is added to or removed from the element the option is set on.<br>
 <br>
 Examples for when this breakpoint is triggered are calling {{domxref("Node.appendChild()")}} and {{domxref("Node.removeChild()")}}, calling {{domxref("ChildNode.remove()")}} or setting {{domxref("Element.innerHTML")}} on one of the subnodes.</dd>
 <dt>Attribute Modification</dt>
 <dd>Execution pauses when any of the elementsʼ attributes are modified.<br>
 That means, the script execution is stopped whenever an attribute is added to or removed from the element the option is set on or the value of one of its attributes is changed.<br>
 <br>
 Examples for when this breakpoint is triggered are calling {{domxref("Element.setAttribute()")}}, {{domxref("Element.removeAttribute()")}}, and <code><a href="/en-US/docs/Web/API/Element/classList#Methods">Element.classList.add()</a></code>, or setting {{domxref("Element.id")}}.</dd>
 <dt>Node Removal</dt>
 <dd>Execution pauses if the element the option is set on is removed.<br>
 <br>
 Examples for when this breakpoint is triggered are calling {{domxref("Element.remove()")}} or {{domxref("Node.removeChild()")}} on its parent node.</dd>
</dl>

<p>Once you set the breakpoint, go to the Debugger. You can see the breakpoint listed in the right-most panel under <strong>DOM Mutation Breakpoints</strong>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16895/DOM_Mutation_breakpoint.png" style="border: 1px solid black; display: block; height: 333px; margin: 0px auto; width: 899px;"></p>

<p>Click on the icon following the node name to go back to the Page Inspector with the node selected.</p>

<p>When you execute the code, the debugger will pause execution when the DOM mutation occurs. In the following example, the selected node (the unordered list) is modified by adding a new child node.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16896/DOM_mutation_paused.png" style="border: 1px solid black; display: block; height: 333px; margin: 0px auto; width: 899px;"></p>

<p>The panel on the right shows that execution is "Paused on DOM mutation" and you, as with any other breakpoint, you can see the call stack and view any Watch expressions you may have set up.</p>

<h2 id="Inline_variable_preview">Inline variable preview</h2>

<p>New in Firefox 71, the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">source pane</a> now gives you an instant preview of the variables on each line of code you've stepped through. See <a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint#Inline_variable_preview">Set a breakpoint &gt; Inline variable preview</a> for more information.</p>
